Index: branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/grid_hgr.f90
===================================================================
--- branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/grid_hgr.f90	(revision 7148)
+++ branches/2016/dev_r6999_CONFIGMAN_1/NEMOGCM/TOOLS/SIREN/src/grid_hgr.f90	(revision 7153)
@@ -85,6 +85,8 @@
 !> @date September, 2015 
 !> - J, Paul : rewrite to SIREN format from $Id: domhgr.F90 5506 2015-06-29 15:19:38Z clevy $
-!> @date October, 2015
+!> @date October, 2016
 !> - J, Paul : update from trunk (revision 6961): add wetting and drying, ice sheet coupling..
+!> - J, Paul : compute coriolis factor at f-point and at t-point 
+!> - J, Paul : do not use anymore special case for ORCA grid
 !>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -146,5 +148,6 @@
    PUBLIC :: tg_e2f
    
-   PUBLIC :: tg_ff
+   PUBLIC :: tg_ff_t
+   PUBLIC :: tg_ff_f
 
    PUBLIC :: tg_gcost
@@ -186,9 +189,9 @@
 !      REAL(dp)          :: d_ppe2_m     
 
-      INTEGER(i4)       :: i_cla     
+!      INTEGER(i4)       :: i_cla     
                 
-      CHARACTER(LEN=lc) :: c_cfg     
+!      CHARACTER(LEN=lc) :: c_cfg     
       INTEGER(i4)       :: i_cfg     
-      INTEGER(i4)       :: i_bench   
+      LOGICAL           :: l_bench   
                 
    END TYPE
@@ -227,5 +230,6 @@
    TYPE(TVAR), SAVE :: tg_e2f
 
-   TYPE(TVAR), SAVE :: tg_ff
+   TYPE(TVAR), SAVE :: tg_ff_t
+   TYPE(TVAR), SAVE :: tg_ff_f
 
    TYPE(TVAR), SAVE :: tg_gcost
@@ -249,5 +253,5 @@
    !> @param[in] jpj
    !-------------------------------------------------------------------
-   SUBROUTINE grid_hgr_init(jpi,jpj,jpk) 
+   SUBROUTINE grid_hgr_init(jpi,jpj,jpk,ld_domcfg) 
       IMPLICIT NONE
       ! Argument      
@@ -255,4 +259,5 @@
       INTEGER(i4), INTENT(IN) :: jpj
       INTEGER(i4), INTENT(IN) :: jpk
+      LOGICAL    , INTENT(IN) :: ld_domcfg
 
       REAL(dp), DIMENSION(jpi,jpj)     :: dl_tmp2D
@@ -292,15 +297,18 @@
       tg_e2f      = var_init('e2f'  ,dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
 
-      tg_ff       = var_init('ff'   ,dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
-
-      tg_gcost     =var_init('gcost',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
-      tg_gcosu     =var_init('gcosu',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
-      tg_gcosv     =var_init('gcosv',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
-      tg_gcosf     =var_init('gcosf',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
-
-      tg_gsint     =var_init('gsint',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
-      tg_gsinu     =var_init('gsinu',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
-      tg_gsinv     =var_init('gsinv',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
-      tg_gsinf     =var_init('gsinf',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+      tg_ff_t     = var_init('ff_t' ,dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+      tg_ff_f     = var_init('ff_f' ,dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+
+      IF( .NOT. ld_domcfg )THEN
+         tg_gcost     =var_init('gcost',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+         tg_gcosu     =var_init('gcosu',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+         tg_gcosv     =var_init('gcosv',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+         tg_gcosf     =var_init('gcosf',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+
+         tg_gsint     =var_init('gsint',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+         tg_gsinu     =var_init('gsinu',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+         tg_gsinv     =var_init('gsinv',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+         tg_gsinf     =var_init('gsinf',dl_tmp2D(:,:)   , dd_fill=dp_fill, id_type=NF90_DOUBLE)
+      ENDIF
 
       ! variable 3D
@@ -308,7 +316,9 @@
 
       tg_tmask   = var_init('tmask'  ,dl_tmp3D(:,:,:), dd_fill=dp_fill_i1, id_type=NF90_BYTE)
-      tg_umask   = var_init('umask'  ,dl_tmp3D(:,:,:), dd_fill=dp_fill_i1, id_type=NF90_BYTE)
-      tg_vmask   = var_init('vmask'  ,dl_tmp3D(:,:,:), dd_fill=dp_fill_i1, id_type=NF90_BYTE)
-      tg_fmask   = var_init('fmask'  ,dl_tmp3D(:,:,:), dd_fill=dp_fill_i1, id_type=NF90_BYTE)
+      IF( .NOT. ld_domcfg )THEN
+         tg_umask   = var_init('umask'  ,dl_tmp3D(:,:,:), dd_fill=dp_fill_i1, id_type=NF90_BYTE)
+         tg_vmask   = var_init('vmask'  ,dl_tmp3D(:,:,:), dd_fill=dp_fill_i1, id_type=NF90_BYTE)
+         tg_fmask   = var_init('fmask'  ,dl_tmp3D(:,:,:), dd_fill=dp_fill_i1, id_type=NF90_BYTE)
+      ENDIF
       
 !      tg_wmask   = var_init('wmask'  ,dl_tmp3D(:,:,:), dd_fill=dp_fill_i1, id_type=NF90_BYTE)
@@ -324,7 +334,8 @@
    !>
    !-------------------------------------------------------------------
-   SUBROUTINE grid_hgr_clean() 
+   SUBROUTINE grid_hgr_clean(ld_domcfg) 
       IMPLICIT NONE
       ! Argument      
+      LOGICAL    , INTENT(IN) :: ld_domcfg
 
       ! local variable
@@ -332,8 +343,4 @@
       !----------------------------------------------------------------
       CALL var_clean(tg_ssmask  )
-      CALL var_clean(tg_tmask   )
-      CALL var_clean(tg_umask   )
-      CALL var_clean(tg_vmask   )
-      CALL var_clean(tg_fmask   )
 
       CALL var_clean(tg_glamt)
@@ -357,16 +364,25 @@
       CALL var_clean(tg_e2f  )
 
-      CALL var_clean(tg_ff   )
-
-      CALL var_clean(tg_gcost )
-      CALL var_clean(tg_gcosu )
-      CALL var_clean(tg_gcosv )
-      CALL var_clean(tg_gcosf )
-
-      CALL var_clean(tg_gsint )
-      CALL var_clean(tg_gsinu )
-      CALL var_clean(tg_gsinv )
-      CALL var_clean(tg_gsinf )
-
+      CALL var_clean(tg_ff_t )
+      CALL var_clean(tg_ff_f )
+
+      IF( .NOT. ld_domcfg )THEN
+         CALL var_clean(tg_gcost )
+         CALL var_clean(tg_gcosu )
+         CALL var_clean(tg_gcosv )
+         CALL var_clean(tg_gcosf )
+
+         CALL var_clean(tg_gsint )
+         CALL var_clean(tg_gsinu )
+         CALL var_clean(tg_gsinv )
+         CALL var_clean(tg_gsinf )
+      ENDIF
+
+      CALL var_clean(tg_tmask   )
+      IF( .NOT. ld_domcfg )THEN
+         CALL var_clean(tg_umask   )
+         CALL var_clean(tg_vmask   )
+         CALL var_clean(tg_fmask   )
+      ENDIF
    END SUBROUTINE grid_hgr_clean
    !-------------------------------------------------------------------
@@ -409,11 +425,11 @@
 !      REAL(dp)          :: dn_ppe2_m   = NF90_FILL_DOUBLE
 
-      ! namcla
-      INTEGER(i4)       :: in_cla      = 0
+!      ! namcla
+!      INTEGER(i4)       :: in_cla      = 0
 
       ! namgrd
-      CHARACTER(LEN=lc) :: cn_cfg      = ''
+!      CHARACTER(LEN=lc) :: cn_cfg      = ''
       INTEGER(i4)       :: in_cfg      = 0
-      INTEGER(i4)       :: in_bench    = 0
+      LOGICAL           :: ln_bench    = .FALSE.
 
       !----------------------------------------------------------------
@@ -433,11 +449,11 @@
 !      &  dn_ppe2_m         !< meridional grid-spacing (degrees)
 
-      NAMELIST /namcla/ &
-      &  in_cla            !< =1 cross land advection for exchanges through some straits (ORCA2)
+!      NAMELIST /namcla/ &
+!      &  in_cla            !< =1 cross land advection for exchanges through some straits (ORCA2)
 
       NAMELIST/namgrd/  &  !< orca grid namelist
-      &  cn_cfg,        &  !< name of the configuration (orca)
+!      &  cn_cfg,        &  !< name of the configuration (orca)
       &  in_cfg,        &  !< resolution of the configuration (2,1,025..)
-      &  in_bench          !< benchmark parameter (in_mshhgr = 5 ). 
+      &  ln_bench          !< benchmark parameter (in_mshhgr = 5 ). 
 
       !----------------------------------------------------------------
@@ -461,6 +477,6 @@
 
          READ( il_fileid, NML = namhgr  )
-         READ( il_fileid, NML = namcla  )
-         READ( il_fileid, NML = namgrd  )
+!         READ( il_fileid, NML = namcla  )
+!         READ( il_fileid, NML = namgrd  )
 
          CLOSE( il_fileid, IOSTAT=il_status )
@@ -482,9 +498,9 @@
 !         grid_hgr_nam%d_ppe2_m  = dn_ppe2_m
 
-         grid_hgr_nam%i_cla     = in_cla
-
-         grid_hgr_nam%c_cfg     = TRIM(cn_cfg)
+!         grid_hgr_nam%i_cla     = in_cla
+
+!         grid_hgr_nam%c_cfg     = TRIM(cn_cfg)
          grid_hgr_nam%i_cfg     = in_cfg
-         grid_hgr_nam%i_bench   = in_bench
+         grid_hgr_nam%l_bench   = ln_bench
 
       ELSE
@@ -505,5 +521,5 @@
    !> @param[in] jpj
    !-------------------------------------------------------------------
-   SUBROUTINE grid_hgr_fill(td_nam,jpi,jpj) 
+   SUBROUTINE grid_hgr_fill(td_nam,jpi,jpj,ld_domcfg) 
       IMPLICIT NONE
       ! Argument      
@@ -511,4 +527,5 @@
       INTEGER(i4), INTENT(IN) :: jpi
       INTEGER(i4), INTENT(IN) :: jpj
+      LOGICAL    , INTENT(IN) :: ld_domcfg
 
       ! local variable
@@ -516,5 +533,5 @@
       ! loop indices
       !----------------------------------------------------------------
-      CALL logger_info('GRIG HGR FILL : define the horizontal mesh from ithe'//&
+      CALL logger_info('GRID HGR FILL : define the horizontal mesh from ithe'//&
       &  ' type of horizontal mesh mshhgr = '//TRIM(fct_str(td_nam%i_mshhgr)))
       IF( td_nam%i_mshhgr == 1 )THEN
@@ -538,5 +555,5 @@
          CASE(0)   !  curvilinear coordinate on the sphere read in coordinate.nc file
 
-            CALL grid_hgr__fill_curv(td_nam,jpi,jpj)
+            CALL grid_hgr__fill_curv(td_nam)!,jpi,jpj)
 
          CASE(1)   ! geographical mesh on the sphere with regular grid-spacing
@@ -558,5 +575,5 @@
          CASE DEFAULT
 
-            CALL logger_fatal('GRIG HGR FILL : bad flag value for mshhgr = '//&
+            CALL logger_fatal('GRID HGR FILL : bad flag value for mshhgr = '//&
                &  TRIM(fct_str(td_nam%i_mshhgr)))
 
@@ -567,5 +584,5 @@
 
       ! create coriolis factor
-      CALL grid_hgr__fill_coriolis(td_nam,jpi,jpj)
+      CALL grid_hgr__fill_coriolis(td_nam,jpi)!,jpj)
      
       ! Control of domain for symetrical condition
@@ -582,5 +599,7 @@
       ! compute angles between model grid lines and the North direction
       ! ---------------------------------------------------------------
-      CALL grid_hgr__angle(td_nam,jpi,jpj) 
+      IF( .NOT. ld_domcfg )THEN
+         CALL grid_hgr__angle(td_nam,jpi,jpj) 
+      ENDIF
 
    END SUBROUTINE grid_hgr_fill
@@ -591,19 +610,21 @@
    !> @author J.Paul
    !> @date September, 2015 - Initial version
+   !> @date October, 2016
+   !> - do not use anymore special case for ORCA grid
    !>
    !> @param[in] td_nam
-   !> @param[in] jpi
-   !> @param[in] jpj   
-   !-------------------------------------------------------------------
-   SUBROUTINE grid_hgr__fill_curv( td_nam,jpi,jpj ) 
+   ! @param[in] jpi
+   ! @param[in] jpj   
+   !-------------------------------------------------------------------
+   SUBROUTINE grid_hgr__fill_curv( td_nam )!,jpi,jpj ) 
       IMPLICIT NONE
       ! Argument      
       TYPE(TNAMH), INTENT(IN) :: td_nam
-      INTEGER(i4), INTENT(IN) :: jpi
-      INTEGER(i4), INTENT(IN) :: jpj
+!      INTEGER(i4), INTENT(IN) :: jpi
+!      INTEGER(i4), INTENT(IN) :: jpj
 
       ! local variable
-      INTEGER(i4) :: ii0, ii1, ij0, ij1   ! temporary integers
-      INTEGER(i4) :: isrow                ! index for ORCA1 starting row
+!      INTEGER(i4) :: ii0, ii1, ij0, ij1   ! temporary integers
+!      INTEGER(i4) :: isrow                ! index for ORCA1 starting row
 
       TYPE(TMPP)  :: tl_coord
@@ -662,156 +683,156 @@
       !! WARNING extended grid have to be correctly fill
 
-      !! special case for ORCA grid
-      ! ORCA R2 configuration
-      IF( TRIM(td_nam%c_cfg) == "orca" .AND. td_nam%i_cfg == 2 ) THEN
-            IF( td_nam%i_cla == 0 ) THEN
-               !
-               ! Gibraltar Strait (e2u = 20 km)
-               ii0 = 139   ;   ii1 = 140
-               ij0 = 102   ;   ij1 = 102   
-               ! e2u = 20 km
-               tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  20.e3
-               CALL logger_info('orca_r2: Gibraltar    : e2u reduced to 20 km')
-               !
-               ! Bab el Mandeb (e2u = 18 km)
-               ii0 = 160   ;   ii1 = 160 
-               ij0 =  88   ;   ij1 =  88   
-               ! e1v = 18 km
-               tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  18.e3
-               ! e2u = 30 km
-               tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  30.e3
-
-               CALL logger_info('orca_r2: Bab el Mandeb: e2u reduced to 30 km')
-               CALL logger_info('e1v reduced to 18 km')
-            ENDIF
-            ! Danish Straits
-            ii0 = 145   ;   ii1 = 146
-            ij0 = 116   ;   ij1 = 116   
-            ! e2u = 10 km
-            tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
-            CALL logger_info('orca_r2: Danish Straits : e2u reduced to 10 km')
-      ENDIF
-
-      ! ORCA R1 configuration
-      IF( TRIM(td_nam%c_cfg) == "orca" .AND. td_nam%i_cfg == 1 ) THEN
-         ! This dirty section will be suppressed by simplification process: all this will come back in input files
-         ! Currently these hard-wired indices relate to configuration with
-         ! extend grid (jpjglo=332)
-         ! which had a grid-size of 362x292.
-
-         isrow = 332 - jpj
-
-         ! Gibraltar Strait (e2u = 20 km)
-         ii0 = 282           ;   ii1 = 283
-         ij0 = 201 + isrow   ;   ij1 = 241 - isrow 
-         ! e2u = 20 km
-         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  20.e3
-         CALL logger_info('orca_r1: Gibraltar : e2u reduced to 20 km')
-
-         ! Bhosporus Strait (e2u = 10 km)
-         ii0 = 314           ;   ii1 = 315        ! Bhosporus Strait (e2u = 10 km)
-         ij0 = 208 + isrow   ;   ij1 = 248 - isrow
-         ! Bhosporus Strait (e2u = 10 km)
-         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
-         CALL logger_info('orca_r1: Bhosporus : e2u reduced to 10 km')
-
-         ! Lombok Strait (e1v = 13 km)
-         ii0 =  44           ;   ii1 =  44        ! Lombok Strait (e1v = 13 km)
-         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
-         ! Lombok Strait (e1v = 13 km)
-         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  13.e3
-         CALL logger_info('orca_r1: Lombok : e1v reduced to 10 km')
-
-         ! Sumba Strait (e1v = 8 km) [closed from bathy_11 on]
-         ii0 =  48           ;   ii1 =  48        ! Sumba Strait (e1v = 8 km) [closed from bathy_11 on]
-         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
-         ! Sumba Strait (e1v = 8 km) [closed from bathy_11 on]
-         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  8.e3
-         CALL logger_info('orca_r1: Sumba : e1v reduced to 8 km')
-
-         ! Ombai Strait (e1v = 13 km)
-         ii0 =  53           ;   ii1 =  53        ! Ombai Strait (e1v = 13 km)
-         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
-         ! Ombai Strait (e1v = 13 km)
-         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) = 13.e3
-         CALL logger_info('orca_r1: Ombai : e1v reduced to 13 km')
-
-         ! Timor Passage (e1v = 20 km)
-         ii0 =  56           ;   ii1 =  56        ! Timor Passage (e1v = 20 km)
-         ij0 = 124 + isrow   ;   ij1 = 145 - isrow
-         ! Timor Passage (e1v = 20 km)
-         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) = 20.e3
-         CALL logger_info('orca_r1: Timor Passage : e1v reduced to 20 km')
-
-          ! West Halmahera Strait (e1v = 30 km)
-         ii0 =  55           ;   ii1 =  55        ! West Halmahera Strait (e1v = 30 km)
-         ij0 = 141 + isrow   ;   ij1 = 182 - isrow
-         ! West Halmahera Strait (e1v = 30 km)
-         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) = 30.e3
-         CALL logger_info('orca_r1: W Halmahera : e1v reduced to 30 km')
-
-         ! East Halmahera Strait (e1v = 50 km)
-         ii0 =  58           ;   ii1 =  58        ! East Halmahera Strait (e1v = 50 km)
-         ij0 = 141 + isrow   ;   ij1 = 182 - isrow
-         ! East Halmahera Strait (e1v = 50 km)
-         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) = 50.e3
-         CALL logger_info('orca_r1: E Halmahera : e1v reduced to 50 km')
-
-      ENDIF
-
-      ! ORCA R05 configuration
-      IF( TRIM(td_nam%c_cfg) == "orca" .AND. td_nam%i_cfg == 05 ) THEN
-
-         ! Gibraltar Strait (e2u = 20 km)
-         ii0 = 563   ;   ii1 = 564        ! Gibraltar Strait (e2u = 20 km)
-         ij0 = 327   ;   ij1 = 327
-         ! Gibraltar Strait (e2u = 20 km)
-         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  20.e3
-         CALL logger_info('orca_r05: Reduced e2u at the Gibraltar Strait')
-         !
-         ! Bosphore Strait (e2u = 10 km)
-         ii0 = 627   ;   ii1 = 628        ! Bosphore Strait (e2u = 10 km)
-         ij0 = 343   ;   ij1 = 343
-         ! Bosphore Strait (e2u = 10 km)
-         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
-         CALL logger_info('orca_r05: Reduced e2u at the Bosphore Strait')
-         !
-         ! Sumba Strait (e2u = 40 km)
-         ii0 =  93   ;   ii1 =  94        ! Sumba Strait (e2u = 40 km)
-         ij0 = 232   ;   ij1 = 232
-         ! Sumba Strait (e2u = 40 km)
-         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  40.e3
-         CALL logger_info('orca_r05: Reduced e2u at the Sumba Strait')
-         !
-         ! Ombai Strait (e2u = 15 km)
-         ii0 = 103   ;   ii1 = 103        ! Ombai Strait (e2u = 15 km)
-         ij0 = 232   ;   ij1 = 232
-         ! Ombai Strait (e2u = 15 km)
-         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  15.e3
-         CALL logger_info('orca_r05: Reduced e2u at the Ombai Strait')
-         !
-         ! Palk Strait (e2u = 10 km)
-         ii0 =  15   ;   ii1 =  15        ! Palk Strait (e2u = 10 km)
-         ij0 = 270   ;   ij1 = 270
-         ! Palk Strait (e2u = 10 km)
-         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
-         CALL logger_info('orca_r05: Reduced e2u at the Palk Strait')
-         !
-         ! Lombok Strait (e1v = 10 km)
-         ii0 =  87   ;   ii1 =  87        ! Lombok Strait (e1v = 10 km)
-         ij0 = 232   ;   ij1 = 233
-         ! Lombok Strait (e1v = 10 km)
-         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
-         CALL logger_info('orca_r05: Reduced e1v at the Lombok Strait')
-         !
-         !
-         ! Bab el Mandeb (e1v = 25 km)
-         ii0 = 662   ;   ii1 = 662        ! Bab el Mandeb (e1v = 25 km)
-         ij0 = 276   ;   ij1 = 276
-         ! Bab el Mandeb (e1v = 25 km)
-         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  25.e3
-         CALL logger_info('orca_r05: Reduced e1v at the Bab el Mandeb')
-
-      ENDIF
+!      !! special case for ORCA grid
+!      ! ORCA R2 configuration
+!      IF( TRIM(td_nam%c_cfg) == "orca" .AND. td_nam%i_cfg == 2 ) THEN
+!            IF( td_nam%i_cla == 0 ) THEN
+!               !
+!               ! Gibraltar Strait (e2u = 20 km)
+!               ii0 = 139   ;   ii1 = 140
+!               ij0 = 102   ;   ij1 = 102   
+!               ! e2u = 20 km
+!               tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  20.e3
+!               CALL logger_info('orca_r2: Gibraltar    : e2u reduced to 20 km')
+!               !
+!               ! Bab el Mandeb (e2u = 18 km)
+!               ii0 = 160   ;   ii1 = 160 
+!               ij0 =  88   ;   ij1 =  88   
+!               ! e1v = 18 km
+!               tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  18.e3
+!               ! e2u = 30 km
+!               tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  30.e3
+!
+!               CALL logger_info('orca_r2: Bab el Mandeb: e2u reduced to 30 km')
+!               CALL logger_info('e1v reduced to 18 km')
+!            ENDIF
+!            ! Danish Straits
+!            ii0 = 145   ;   ii1 = 146
+!            ij0 = 116   ;   ij1 = 116   
+!            ! e2u = 10 km
+!            tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
+!            CALL logger_info('orca_r2: Danish Straits : e2u reduced to 10 km')
+!      ENDIF
+!
+!      ! ORCA R1 configuration
+!      IF( TRIM(td_nam%c_cfg) == "orca" .AND. td_nam%i_cfg == 1 ) THEN
+!         ! This dirty section will be suppressed by simplification process: all this will come back in input files
+!         ! Currently these hard-wired indices relate to configuration with
+!         ! extend grid (jpjglo=332)
+!         ! which had a grid-size of 362x292.
+!
+!         isrow = 332 - jpj
+!
+!         ! Gibraltar Strait (e2u = 20 km)
+!         ii0 = 282           ;   ii1 = 283
+!         ij0 = 201 + isrow   ;   ij1 = 241 - isrow 
+!         ! e2u = 20 km
+!         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  20.e3
+!         CALL logger_info('orca_r1: Gibraltar : e2u reduced to 20 km')
+!
+!         ! Bhosporus Strait (e2u = 10 km)
+!         ii0 = 314           ;   ii1 = 315        ! Bhosporus Strait (e2u = 10 km)
+!         ij0 = 208 + isrow   ;   ij1 = 248 - isrow
+!         ! Bhosporus Strait (e2u = 10 km)
+!         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
+!         CALL logger_info('orca_r1: Bhosporus : e2u reduced to 10 km')
+!
+!         ! Lombok Strait (e1v = 13 km)
+!         ii0 =  44           ;   ii1 =  44        ! Lombok Strait (e1v = 13 km)
+!         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
+!         ! Lombok Strait (e1v = 13 km)
+!         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  13.e3
+!         CALL logger_info('orca_r1: Lombok : e1v reduced to 10 km')
+!
+!         ! Sumba Strait (e1v = 8 km) [closed from bathy_11 on]
+!         ii0 =  48           ;   ii1 =  48        ! Sumba Strait (e1v = 8 km) [closed from bathy_11 on]
+!         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
+!         ! Sumba Strait (e1v = 8 km) [closed from bathy_11 on]
+!         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  8.e3
+!         CALL logger_info('orca_r1: Sumba : e1v reduced to 8 km')
+!
+!         ! Ombai Strait (e1v = 13 km)
+!         ii0 =  53           ;   ii1 =  53        ! Ombai Strait (e1v = 13 km)
+!         ij0 = 124 + isrow   ;   ij1 = 165 - isrow
+!         ! Ombai Strait (e1v = 13 km)
+!         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) = 13.e3
+!         CALL logger_info('orca_r1: Ombai : e1v reduced to 13 km')
+!
+!         ! Timor Passage (e1v = 20 km)
+!         ii0 =  56           ;   ii1 =  56        ! Timor Passage (e1v = 20 km)
+!         ij0 = 124 + isrow   ;   ij1 = 145 - isrow
+!         ! Timor Passage (e1v = 20 km)
+!         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) = 20.e3
+!         CALL logger_info('orca_r1: Timor Passage : e1v reduced to 20 km')
+!
+!          ! West Halmahera Strait (e1v = 30 km)
+!         ii0 =  55           ;   ii1 =  55        ! West Halmahera Strait (e1v = 30 km)
+!         ij0 = 141 + isrow   ;   ij1 = 182 - isrow
+!         ! West Halmahera Strait (e1v = 30 km)
+!         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) = 30.e3
+!         CALL logger_info('orca_r1: W Halmahera : e1v reduced to 30 km')
+!
+!         ! East Halmahera Strait (e1v = 50 km)
+!         ii0 =  58           ;   ii1 =  58        ! East Halmahera Strait (e1v = 50 km)
+!         ij0 = 141 + isrow   ;   ij1 = 182 - isrow
+!         ! East Halmahera Strait (e1v = 50 km)
+!         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) = 50.e3
+!         CALL logger_info('orca_r1: E Halmahera : e1v reduced to 50 km')
+!
+!      ENDIF
+!
+!      ! ORCA R05 configuration
+!      IF( TRIM(td_nam%c_cfg) == "orca" .AND. td_nam%i_cfg == 05 ) THEN
+!
+!         ! Gibraltar Strait (e2u = 20 km)
+!         ii0 = 563   ;   ii1 = 564        ! Gibraltar Strait (e2u = 20 km)
+!         ij0 = 327   ;   ij1 = 327
+!         ! Gibraltar Strait (e2u = 20 km)
+!         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  20.e3
+!         CALL logger_info('orca_r05: Reduced e2u at the Gibraltar Strait')
+!         !
+!         ! Bosphore Strait (e2u = 10 km)
+!         ii0 = 627   ;   ii1 = 628        ! Bosphore Strait (e2u = 10 km)
+!         ij0 = 343   ;   ij1 = 343
+!         ! Bosphore Strait (e2u = 10 km)
+!         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
+!         CALL logger_info('orca_r05: Reduced e2u at the Bosphore Strait')
+!         !
+!         ! Sumba Strait (e2u = 40 km)
+!         ii0 =  93   ;   ii1 =  94        ! Sumba Strait (e2u = 40 km)
+!         ij0 = 232   ;   ij1 = 232
+!         ! Sumba Strait (e2u = 40 km)
+!         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  40.e3
+!         CALL logger_info('orca_r05: Reduced e2u at the Sumba Strait')
+!         !
+!         ! Ombai Strait (e2u = 15 km)
+!         ii0 = 103   ;   ii1 = 103        ! Ombai Strait (e2u = 15 km)
+!         ij0 = 232   ;   ij1 = 232
+!         ! Ombai Strait (e2u = 15 km)
+!         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  15.e3
+!         CALL logger_info('orca_r05: Reduced e2u at the Ombai Strait')
+!         !
+!         ! Palk Strait (e2u = 10 km)
+!         ii0 =  15   ;   ii1 =  15        ! Palk Strait (e2u = 10 km)
+!         ij0 = 270   ;   ij1 = 270
+!         ! Palk Strait (e2u = 10 km)
+!         tg_e2u%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
+!         CALL logger_info('orca_r05: Reduced e2u at the Palk Strait')
+!         !
+!         ! Lombok Strait (e1v = 10 km)
+!         ii0 =  87   ;   ii1 =  87        ! Lombok Strait (e1v = 10 km)
+!         ij0 = 232   ;   ij1 = 233
+!         ! Lombok Strait (e1v = 10 km)
+!         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  10.e3
+!         CALL logger_info('orca_r05: Reduced e1v at the Lombok Strait')
+!         !
+!         !
+!         ! Bab el Mandeb (e1v = 25 km)
+!         ii0 = 662   ;   ii1 = 662        ! Bab el Mandeb (e1v = 25 km)
+!         ij0 = 276   ;   ij1 = 276
+!         ! Bab el Mandeb (e1v = 25 km)
+!         tg_e1v%d_value(ii0:ii1,ij0:ij1,1,1) =  25.e3
+!         CALL logger_info('orca_r05: Reduced e1v at the Bab el Mandeb')
+!
+!      ENDIF
 
    END SUBROUTINE grid_hgr__fill_curv
@@ -1071,10 +1092,8 @@
       ze1 = 106000. / FLOAT(td_nam%i_cfg)            
       ! benchmark: forced the resolution to be about 100 km
-      IF( td_nam%i_bench /= 0 )   ze1 = 106000.e0     
+      IF( td_nam%l_bench )   ze1 = 106000.e0     
       zsin_alpha = - SQRT( 2. ) / 2.
       zcos_alpha =   SQRT( 2. ) / 2.
       ze1deg = ze1 / (dp_rearth * dp_deg2rad)
-      ! benchmark: keep the lat/+lon at the right in_cfg resolution
-      IF( td_nam%i_bench /= 0 )   ze1deg = ze1deg / FLOAT(td_nam%i_cfg)
       dl_glam0 = zlam1 + zcos_alpha * ze1deg * FLOAT( jpj-2 )
       dl_gphi0 = zphi1 + zsin_alpha * ze1deg * FLOAT( jpj-2 )
@@ -1134,15 +1153,17 @@
    !> @author J.Paul
    !> @date September, 2015 - Initial version
+   !> @date October, 2016
+   !> - compute coriolis factor at f-point and at t-point
    !>
    !> @param[in] td_nam
    !> @param[in] jpi
-   !> @param[in] jpj
-   !-------------------------------------------------------------------
-   SUBROUTINE grid_hgr__fill_coriolis(td_nam,jpi,jpj) 
+   ! @param[in] jpj
+   !-------------------------------------------------------------------
+   SUBROUTINE grid_hgr__fill_coriolis(td_nam,jpi)!,jpj) 
       IMPLICIT NONE
       ! Argument      
       TYPE(TNAMH), INTENT(IN) :: td_nam
       INTEGER(i4), INTENT(IN) :: jpi
-      INTEGER(i4), INTENT(IN) :: jpj
+!      INTEGER(i4), INTENT(IN) :: jpj
 
       ! local variable
@@ -1159,11 +1180,13 @@
          CASE ( 0, 1, 4 ) ! mesh on the sphere
 
-            tg_ff%d_value(:,:,1,1) = 2. * dp_omega * SIN(dp_deg2rad * tg_gphif%d_value(:,:,1,1))
+            tg_ff_f%d_value(:,:,1,1) = 2. * dp_omega * SIN(dp_deg2rad * tg_gphif%d_value(:,:,1,1))
+            tg_ff_t%d_value(:,:,1,1) = 2. * dp_omega * SIN(dp_deg2rad * tg_gphit%d_value(:,:,1,1)) ! at t-point
 
          CASE ( 2 )  ! f-plane at ppgphi0 
 
-            tg_ff%d_value(:,:,1,1) = 2. * dp_omega * SIN( dp_deg2rad * td_nam%d_ppgphi0 )
+            tg_ff_f%d_value(:,:,1,1) = 2. * dp_omega * SIN( dp_deg2rad * td_nam%d_ppgphi0 )
+            tg_ff_t%d_value(:,:,1,1) = 2. * dp_omega * SIN( dp_deg2rad * td_nam%d_ppgphi0 )
             CALL logger_info('f-plane: Coriolis parameter = constant = '//&
-               &  TRIM(fct_str(tg_ff%d_value(1,1,1,1))) )
+               &  TRIM(fct_str(tg_ff_f%d_value(1,1,1,1))) )
 
          CASE ( 3 )  ! beta-plane
@@ -1178,5 +1201,6 @@
             zf0 = 2. * dp_omega * SIN( dp_deg2rad * zphi0 )
             ! f = f0 +beta* y ( y=0 at south)
-            tg_ff%d_value(:,:,1,1) = zf0 + zbeta * tg_gphif%d_value(:,:,1,1) * 1.e3
+            tg_ff_f%d_value(:,:,1,1) = zf0 + zbeta * tg_gphif%d_value(:,:,1,1) * 1.e3
+            tg_ff_t%d_value(:,:,1,1) = zf0 + zbeta * tg_gphit%d_value(:,:,1,1) * 1.e3
 
          CASE ( 5 )  ! beta-plane and rotated domain (gyre configuration)
@@ -1190,5 +1214,8 @@
 
             ! f = f0 +beta* y ( y=0 at south)
-            tg_ff%d_value(:,:,1,1) = ( zf0 + zbeta * ABS( tg_gphif%d_value(:,:,1,1) - zphi0 ) * dp_deg2rad * dp_rearth )
+            tg_ff_f%d_value(:,:,1,1) = ( zf0 + zbeta * ABS( tg_gphif%d_value(:,:,1,1) - zphi0 ) &
+                                     & * dp_deg2rad * dp_rearth )
+            tg_ff_t%d_value(:,:,1,1) = ( zf0 + zbeta * ABS( tg_gphit%d_value(:,:,1,1) - zphi0 ) &
+                                     & * dp_deg2rad * dp_rearth )
 
       END SELECT
